               /*ͻ
                C Easy sample9.c: Bar and PullDown Menu 
               */

#include "\ceasy\ceasy1.h"       // required C Easy header files
#include "\ceasy\ceasy2.h"

#define barline         3
#define barcolumn       23
#define top             7
#define width_menu1     16
#define width_submenu1  11
#define width_submenu2  11
#define start_menu1     7
#define start_submenu1  9
#define start_submenu2  10

#define width_menu2     19
#define start_menu2     33

char menu1 [] [ width_menu1 ] =
 {
  "0 Cancel        ",
  "1 Submenu One   ",
  "2 Submenu Two   "
 };

char submenu1 [] [ width_submenu1 ] =
 {
  "0 Cancel   ",
  "1 Sample 1 ",
  "2 Sample 2 ",
  "3 Sample 3 ",
  "4 Sample 4 "
 };

char submenu2 [] [ width_submenu2 ] =
 {
  "0 Cancel   ",
  "1 Sample 5 ",
  "2 Sample 6 ",
  "3 Sample 7 "
 };

char menu2 [] [ width_menu2 ] =
 {
  "0 Cancel   ",
  "1 Sample Program 8 ",
  "2 THIS PROGRAM     ",
  "3 Sample Program A ",
  "4 Sample Program B ",
  "5 Sample Program C ",
  "6 Sample Program D ",
  "7 Sample Program F ",
  "8 Sample Program G "
 };

main()
{
 char *command;
 int lastchar, wosave;

 start_program ();               // required

 initialize ();                  // screen colors & memory initialization
 wosave=0;                       // starting window offset

 while (1)
  {
   command =
   select_across ( barline, barcolumn );

   switch ( toupper ( (int) *command ) )
    {
     case ( 'S' ) :

     AUTO_COMMAND         = OFF;
     WINDOW_OFFSET        = wosave;
     WINDOW_OFFSET_COLUMN = 0;

     lastchar =
     select_down ( 0,
                   menu1,
                   sizeof(menu1),
                   width_menu1,
                   sizeof(menu1)/width_menu1,
                   top,
                   start_menu1,
                   NULL,
                   NULL
                 );

     wosave = LAST_LINE-1;

     switch ( (int) lastchar )
      {
       case ( '0' ) :

         restore_window ( 0,
                          width_menu1,
                          sizeof(menu1)/width_menu1,
                          top,
                          start_menu1
                        );
         continue;


       case ( '1' ) :

         lastchar =
         select_command ( 1,
                          submenu1,
                          sizeof(submenu1),
                          width_submenu1,
                          sizeof(submenu1)/width_submenu1,
                          top+3,
                          start_submenu1,
                          NULL,
                          NULL
                        );

         switch ( (int) lastchar )
          {
           case ( '1' ) :

             call_program ("sample1", NULL);
             initialize();
             break;

           case ( '2' ) :

             call_program ("sample2", NULL);
             initialize();
             break;

           case ( '3' ) :

             call_program ("sample3", NULL);
             initialize();
             break;

           case ( '4' ) :

             call_program ("sample4", NULL);
             initialize();
             break;

           default :

              wosave = 0;
              restore_window ( 1,
                               width_submenu1,
                               sizeof(submenu1)/width_submenu1,
                               top+3,
                               start_submenu1
                             );

              restore_window ( 0,
                               width_menu1,
                               sizeof(menu1)/width_menu1,
                               top,
                               start_menu1
                             );
              break;
          }

         continue;

       case ('2') :

       lastchar =
       select_command ( 1,
                        submenu2,
                        sizeof(submenu2),
                        width_submenu2,
                        sizeof(submenu2)/width_submenu2,
                        top+4,
                        start_submenu2,
                        NULL,
                        NULL
                      );

       switch ( (int) lastchar )
        {
         case ( '1' ) :

           call_program ("sample5", NULL);
           initialize();
           break;

         case ( '2' ) :

           call_program ("sample6", NULL);
           initialize();
           break;

         case ( '3' ) :

           call_program ("sample7", NULL);
           initialize();
           break;

         default :

           restore_window ( 1,
                            width_submenu2,
                            sizeof(submenu2)/width_submenu2,
                            top+4,
                            start_submenu2
                          );

           restore_window ( 0,
                            width_menu1,
                            sizeof(menu1)/width_menu1,
                            top,
                            start_menu1
                          );

           break;
        }
       continue;

       default :

          wosave = 0;
          restore_window ( 0,
                           width_menu1,
                           sizeof(menu1)/width_menu1,
                           top,
                           start_menu1
                         );
          break;
      }
     continue;

     case ( 'M' ) :

     AUTO_COMMAND         = OFF;
     WINDOW_OFFSET        = wosave;
     WINDOW_OFFSET_COLUMN = 0;

     lastchar =
     select_down ( 0,
                   menu2,
                   sizeof(menu2),
                   width_menu2,
                   sizeof(menu2)/width_menu2,
                   top,
                   start_menu2,
                   NULL,
                   NULL
                 );

     wosave = LAST_LINE-1;

     switch ( (int) lastchar )
      {
       case ( '1' ) :

          call_program ("sample8", NULL);
          initialize();
          break;

       case ( '2' ) :

          call_program ("sample9", NULL);
          initialize();
          break;

       case ( '3' ) :

          call_program ("sampleA", NULL);
          initialize();
          break;

       case ( '4' ) :

          call_program ("sampleB", NULL);
          initialize();
          break;

       case ( '5' ) :

          call_program ("sampleC", NULL);
          initialize();
          break;

       case ( '6' ) :

          call_program ("sampleD", NULL);
          initialize();
          break;

       case ( '7' ) :

          call_program ("sampleF", NULL);
          initialize();
          break;

       case ( '8' ) :

          call_program ("sampleG", NULL);
          initialize();
          break;
       default :

          restore_window ( 0,
                           width_menu2,
                           sizeof(menu2)/width_menu2,
                           top,
                           start_menu2
                         );
          break;
      }

     BEGIN_SELECT = start_menu2 - 1;
     continue;

     case ( 'E' ) :

       use_palette ("default.pal");
       stop_program (0);

     default :

       break;
    }

   initialize();
  }
}

int initialize ()
{
 while(kbhit());

 BKGND_WINDOW  = BKGND_GRAY   ;  // background color for window
 FGND_WINDOW   = FGND_RED     ;  // foreground color for window
 FRAME_TYPE    = DOUBLE_LINE  ;  // window frame double line (not single)
 BKGND_FRAME   = BKGND_GRAY   ;  // backgound color for window frame
 FGND_FRAME    = FGND_RED     ;  // foregound color for window frame
 SHADOW_TYPE   = RIGHT_SHADOW ;  // frame shadow on right (not left)
 BKGND_SHADOW  = BKGND_BLACK  ;  // frame shadow color
 BKGND_TIME    = BKGND_CYAN   ;  // background color for time display
 FGND_TIME     = FGND_BLUE    ;
 FGND_FORM     = FGND_GRAY    ;
 BKGND_FORM    = BKGND_BLUE   ;
 BKGND_COLOR   = FGND_BLUE    ;
 BKGND_COMMAND = BKGND_GRAY   ;
 FGND_COMMAND  = FGND_RED     ;
 BKGND_BAR     = BKGND_BLACK  ;
 FGND_BAR      = FGND_RED     ;
 BKGND_FORM    = BKGND_BLUE   ;

 enable_time ( 'C', SL, 66 );     // enable mouse and display time
 use_palette ( "sample9.pal" );
 read_form ( "sample9" );
 AUTO_COMMAND = ON;
 restore_text_screen ( "sample9.scr" );
 return(0);
}
